.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include gdi32.inc
includelib gdi32.lib

;***************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

x_to_sel proto xPos:DWORD,pStr:DWORD

;***************************************************************************************************

WIN_WIDTH       equ 600
WIN_HEIGHT      equ 80

STOCK_FONT      equ DEFAULT_GUI_FONT
;;mono: ANSI_FIXED_FONT, OEM_FIXED_FONT, SYSTEM_FIXED_FONT
;;var : ANSI_VAR_FONT, DEFAULT_GUI_FONT, SYSTEM_FONT

;***************************************************************************************************

.const
ClassName   db "charsel",0
AppName     db "Click a character",0
test_str    db "this is a test string... abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789",0

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
selected    DWORD       ?
char_width  dd (256-32) dup (?)
char_x      DWORD       ?

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;***************************************************************************************************

WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov [wc].cbSize,SIZEOF wc
    mov [wc].style,CS_HREDRAW or CS_VREDRAW
    mov [wc].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [wc].hInstance,eax
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov [wc].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [wc].hCursor,eax
    mov [wc].hbrBackground,COLOR_WINDOW+1
    mov [wc].lpszClassName,OFFSET ClassName
    xor eax,eax
    mov [wc].cbClsExtra,eax
    mov [wc].cbWndExtra,eax
    mov [wc].lpszMenuName,eax
    mov [wc].hIconSm,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,WIN_WIDTH,WIN_HEIGHT,NULL,NULL,hInstance,NULL
    .IF (eax)
        push ebx
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        lea ebx,[msg]
        assume ebx:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, ebx,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, ebx
            invoke DispatchMessage, ebx
        .ENDW
        mov eax,[ebx].wParam
        assume ebx:nothing
        pop ebx
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL ps:PAINTSTRUCT
    mov eax,uMsg
;-- WM_PAINT ---------------------------------------------------------------------------------------
    .IF (eax==WM_PAINT)
        push ebx
        invoke BeginPaint, hwnd,ADDR ps
        mov ebx,eax
        invoke GetStockObject, STOCK_FONT
        invoke SelectObject, ebx,eax
        invoke TextOut, ebx,0,5,ADDR test_str,SIZEOF test_str-1
        .IF (selected != -1)
            invoke SetTextColor, ebx,00000ffh
            mov edx,selected
            add edx,OFFSET test_str
            invoke TextOut, ebx,char_x,5,edx,1
        .ENDIF
        invoke EndPaint, hwnd,ADDR ps
        pop ebx
;-- WM_LBUTTONDOWN ---------------------------------------------------------------------------------
    .ELSEIF (eax==WM_LBUTTONDOWN)
        mov eax,lParam
        mov edx,eax
        and eax,0ffffh  ;xPos
        shr edx,16      ;yPos
        invoke x_to_sel, eax,ADDR test_str
        mov selected,eax
        invoke InvalidateRect, hwnd,NULL,FALSE
;-- WM_CREATE --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        mov eax,-1
        mov selected,eax
        push ebx
        invoke GetWindowDC, hwnd
        mov ebx,eax
        invoke GetStockObject, STOCK_FONT
        invoke SelectObject, ebx,eax
        invoke GetCharWidth32, ebx,32,255,ADDR char_width
        invoke ReleaseDC, hwnd,ebx
        pop ebx
;-- WM_DESTROY -------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke PostQuitMessage, NULL
;-- default ----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

;***************************************************************************************************

x_to_sel proc xPos:DWORD,pStr:DWORD
    push esi
    push edi
    push ebx
    mov esi,OFFSET char_width
    mov edi,pStr
    xor eax,eax
    xor ecx,ecx             ;index into pStr
    xor ebx,ebx             ;accumulated width
  @@:
    mov al,[edi+ecx]        ;al = str[i]
    sub al,32
    jb @fail                ;say none was clicked if we get to end of string, or control char
    mov edx,[esi+4*eax]
    add ebx,edx             ;accumWidth += char_width[eax]
    cmp ebx,xPos
    jge @out                ;if (accumWidth >= xPos) we've_found_it!
    inc ecx                 ;else, move onto next char in pStr
    jmp @B
  @fail:
    mov ecx,-1
  @out:
    ;;;
    sub ebx,edx     ;;HACK! - so we can overdraw the
    mov char_x,ebx  ;;selected char in red
    ;;;
    mov eax,ecx
    pop ebx
    pop edi
    pop esi
    ret
x_to_sel endp

;***************************************************************************************************

end start
